using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;

namespace CNC3AutoReplay
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        public static int lastreplay = 0;
        public static String config = Application.StartupPath + @"\config.ini";
        public static bool listen = false;
        public static bool autostart = false;
        public static String dir = String.Empty;
        public static bool start = true;

        [DllImport("kernel32.dll")]
        private static extern bool GetPrivateProfileString(String section, String key, String error, StringBuilder buffer, int Size, String file);

        [DllImport("kernel32.dll")]
        private static extern bool WritePrivateProfileString(String section, String key, String value, String file);

        private void Exit(object sender, EventArgs e)
        {
            if (MessageBox.Show("Are you sure you wish to exit?", "Confirm Exit", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                Application.Exit();
            }
        }

        private void ShowFolderDiag(object sender, EventArgs e)
        {
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
            {
                textBox1.Text = folderBrowserDialog1.SelectedPath;

                if (!textBox1.Text.EndsWith(@"\"))
                {
                    textBox1.AppendText(@"\");
                }

                dir = textBox1.Text;
                fileSystemWatcher1.Path = dir;

                WritePrivateProfileString("Config", "Path", dir, config);
            }
        }

        private void ShowAboutDiag(object sender, EventArgs e)
        {
            MessageBox.Show("Designed and coded by Dave S. Anderson\r\n\r\nhttp://www.dcomproductions.net/\r\nhttp://forums.dcomproductions.net/", "About");
        }

        private void ToggleAutostart(object sender, EventArgs e)
        {
            if (autostart == true)
            {
                autostart = false;
                this.autostartToolStripMenuItem.Checked = false;
                WritePrivateProfileString("Config", "Autostart", false.ToString(), config);
                MessageBox.Show("Autostart:  Off", "Autostart");
            }
            else
            {
                autostart = true;
                this.autostartToolStripMenuItem.Checked = true;
                WritePrivateProfileString("Config", "Autostart", true.ToString(), config);
                MessageBox.Show("Autostart:  On", "Autostart");
            }
        }

        private void Enable(object sender, EventArgs e)
        {
            this.backgroundWorker1 = new BackgroundWorker();
            this.backgroundWorker1.WorkerSupportsCancellation = true;
            this.backgroundWorker1.DoWork += new System.ComponentModel.DoWorkEventHandler(this.DeleteFile);
            this.backgroundWorker1.RunWorkerAsync();
            listen = true;
            this.btnEnable.Enabled = false;
            this.btnDisable.Enabled = true;
            this.enableToolStripMenuItem.Enabled = false;
            this.disableToolStripMenuItem.Enabled = true;
        }

        private void Disable(object sender, EventArgs e)
        {
            this.backgroundWorker1.CancelAsync();
            this.backgroundWorker1.Dispose();

            listen = false;
            this.btnEnable.Enabled = true;
            this.btnDisable.Enabled = false;
            this.enableToolStripMenuItem.Enabled = true;
            this.disableToolStripMenuItem.Enabled = false;
        }

        private void SaveReplay(object sender, System.IO.FileSystemEventArgs e)
        {
            if (listen == true && File.Exists(dir + @"\Last Replay.CNC3Replay"))
            {
                if (e.Name == "Last Replay.CNC3Replay")
                {
                    FileInfo file = new FileInfo(e.FullPath);
                    file.CopyTo(file.DirectoryName + @"\cnc3_replay_" + lastreplay.ToString() + ".CNC3Replay", true);
                    WritePrivateProfileString("Config", "LastReplay", lastreplay.ToString(), config);
                }
            }
        }

        private void LoadConfig(object sender, EventArgs e)
        {
            if (!File.Exists(config))
            {
                File.Create(config).Close();

                WritePrivateProfileString("Config", "Path", "C:\\", config);
                WritePrivateProfileString("Config", "Autostart", false.ToString(), config);
                WritePrivateProfileString("Config", "LastReplay", lastreplay.ToString(), config);
            }

            StringBuilder buffer = new StringBuilder(256);

            GetPrivateProfileString("Config", "Path", "C:\\", buffer, 256, config);
            textBox1.Text = buffer.ToString();
            dir = textBox1.Text;
            try
            {
                fileSystemWatcher1.Path = dir;
            }
            catch
            {
                //
            }

            GetPrivateProfileString("Config", "Autostart", "error", buffer, 256, config);
            autostart = bool.Parse(buffer.ToString());

            GetPrivateProfileString("Config", "LastReplay", "error", buffer, 256, config);
            lastreplay = int.Parse(buffer.ToString());

            if (File.Exists(dir + @"\Last Replay.CNC3Replay"))
            {
                File.Delete(dir + @"\Last Replay.CNC3Replay");
            }

            try
            {
                fileSystemWatcher1.NotifyFilter = NotifyFilters.Attributes | NotifyFilters.FileName | NotifyFilters.LastAccess | NotifyFilters.LastWrite | NotifyFilters.Security | NotifyFilters.Size | NotifyFilters.CreationTime | NotifyFilters.DirectoryName;
            }
            catch
            {
                //
            }

            if (autostart == true)
            {
                this.autostartToolStripMenuItem.Checked = true;
                Enable(null, new EventArgs());
                minimizeToTrayToolStripMenuItem_Click(this, new EventArgs());

                // DEBUG
                // THE FORUM WILL NOT HIDE ITSELF
                //
                // NEEDS REVISING
            }
            else
            {
                this.autostartToolStripMenuItem.Checked = false;
                Disable(this, new EventArgs());
            }
        }

        private void DeletedEvent(object sender, FileSystemEventArgs e)
        {
            if (e.Name == "Last Replay.CNC3Replay")
            {
                lastreplay++;
            }
        }

        private void DeleteFile(object sender, DoWorkEventArgs e)
        {
            while (true)
            {
                System.Threading.Thread.Sleep(100);

                try
                {
                    File.Delete(dir + @"\Last Replay.CNC3Replay");
                }
                catch
                {
                    //
                }
            }
        }

        private void minimizeToTrayToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.minimizeToTrayToolStripMenuItem.Enabled = false;
            this.restoreToolStripMenuItem.Enabled = true;
            this.Hide();
        }

        private void restoreToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.minimizeToTrayToolStripMenuItem.Enabled = true;
            this.restoreToolStripMenuItem.Enabled = false;
            this.Show();
        }

        private void Closing(object sender, FormClosingEventArgs e)
        {
            if (e.CloseReason == CloseReason.UserClosing || e.CloseReason == CloseReason.FormOwnerClosing)
            {
                if (MessageBox.Show("Are you sure you wish to exit?", "Confirm Exit", MessageBoxButtons.YesNo) == DialogResult.No)
                {
                    this.notifyIcon1.Dispose();
                    e.Cancel = true;
                }
            }
        }

        private void HideIt(object sender, EventArgs e)
        {
            if (autostart == true && start == true)
            {
                start = false;
                this.Hide();
            }
        }
    }
}